#[doc = "<s>Vulkan Manual Page</s> · Constant <br/> "]
#[doc(alias = "VK_HUAWEI_SUBPASS_SHADING_SPEC_VERSION")]
pub const HUAWEI_SUBPASS_SHADING_SPEC_VERSION: u32 = 2;
#[doc = "<s>Vulkan Manual Page</s> · Constant <br/> "]
#[doc(alias = "VK_HUAWEI_SUBPASS_SHADING_EXTENSION_NAME")]
pub const HUAWEI_SUBPASS_SHADING_EXTENSION_NAME: *const std::os::raw::c_char = crate::cstr!("VK_HUAWEI_subpass_shading");
#[doc = "<s>Vulkan Manual Page</s> · Constant <br/> "]
pub const FN_GET_DEVICE_SUBPASS_SHADING_MAX_WORKGROUP_SIZE_HUAWEI: *const std::os::raw::c_char = crate::cstr!("vkGetDeviceSubpassShadingMaxWorkgroupSizeHUAWEI");
#[doc = "<s>Vulkan Manual Page</s> · Constant <br/> "]
pub const FN_CMD_SUBPASS_SHADING_HUAWEI: *const std::os::raw::c_char = crate::cstr!("vkCmdSubpassShadingHUAWEI");
#[doc = "Provided by [`crate::extensions::huawei_subpass_shading`]"]
impl crate::extensions::khr_synchronization2::PipelineStageFlagBits2KHR {
    pub const SUBPASS_SHADING_HUAWEI: Self = Self(549755813888);
}
#[doc = "Provided by [`crate::extensions::huawei_subpass_shading`]"]
impl crate::vk1_0::PipelineBindPoint {
    pub const SUBPASS_SHADING_HUAWEI: Self = Self(1000369003);
}
#[doc = "Provided by [`crate::extensions::huawei_subpass_shading`]"]
impl crate::vk1_0::ShaderStageFlagBits {
    pub const SUBPASS_SHADING_HUAWEI: Self = Self(16384);
}
#[doc = "Provided by [`crate::extensions::huawei_subpass_shading`]"]
impl crate::vk1_0::StructureType {
    pub const SUBPASS_SHADING_PIPELINE_CREATE_INFO_HUAWEI: Self = Self(1000369000);
    pub const PHYSICAL_DEVICE_SUBPASS_SHADING_FEATURES_HUAWEI: Self = Self(1000369001);
    pub const PHYSICAL_DEVICE_SUBPASS_SHADING_PROPERTIES_HUAWEI: Self = Self(1000369002);
}
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/vkGetDeviceSubpassShadingMaxWorkgroupSizeHUAWEI.html)) · Function <br/> vkGetDeviceSubpassShadingMaxWorkgroupSizeHUAWEI - Query maximum supported subpass shading workgroup size for a give render pass\n[](#_c_specification)C Specification\n----------\n\nA subpass shading pipeline’s workgroup size is a 2D vector with number of\npower-of-two in width and height.\nThe maximum number of width and height is implementation dependent, and **may**vary for different formats and sample counts of attachments in a render\npass.\n\nTo query the maximum workgroup size, call:\n\n```\n// Provided by VK_HUAWEI_subpass_shading\nVkResult vkGetDeviceSubpassShadingMaxWorkgroupSizeHUAWEI(\n    VkDevice                                    device,\n    VkRenderPass                                renderpass,\n    VkExtent2D*                                 pMaxWorkgroupSize);\n```\n[](#_parameters)Parameters\n----------\n\n* [`Self::device`] is a handle to a local device object that was used to\n  create the given render pass.\n\n* `renderPass` is a handle to a render pass object describing the\n  environment in which the pipeline will be used; the pipeline **must** only\n  be used with an instance of any render pass compatible with the one\n  provided.\n  See [Render Pass Compatibility](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/html/vkspec.html#renderpass-compatibility) for more\n  information.\n\n* [`Self::p_max_workgroup_size`] is a pointer to a [`crate::vk::Extent2D`] structure.\n[](#_description)Description\n----------\n\nValid Usage (Implicit)\n\n* []() VUID-vkGetDeviceSubpassShadingMaxWorkgroupSizeHUAWEI-device-parameter  \n  [`Self::device`] **must** be a valid [`crate::vk::Device`] handle\n\n* []() VUID-vkGetDeviceSubpassShadingMaxWorkgroupSizeHUAWEI-renderpass-parameter  \n  [`Self::renderpass`] **must** be a valid [`crate::vk::RenderPass`] handle\n\n* []() VUID-vkGetDeviceSubpassShadingMaxWorkgroupSizeHUAWEI-pMaxWorkgroupSize-parameter  \n  [`Self::p_max_workgroup_size`] **must** be a valid pointer to a [`crate::vk::Extent2D`] structure\n\n* []() VUID-vkGetDeviceSubpassShadingMaxWorkgroupSizeHUAWEI-renderpass-parent  \n  [`Self::renderpass`] **must** have been created, allocated, or retrieved from [`Self::device`]\n\nReturn Codes\n\nOn success, this command returns\n\n* [`crate::vk::Result::SUCCESS`]\n\n* [`crate::vk::Result::INCOMPLETE`]\n\nOn failure, this command returns\n\n* [`crate::vk::Result::ERROR_OUT_OF_HOST_MEMORY`]\n\n* [`crate::vk::Result::ERROR_OUT_OF_DEVICE_MEMORY`]\n\n* [`crate::vk::Result::ERROR_SURFACE_LOST_KHR`]\n[](#_see_also)See Also\n----------\n\n[`crate::vk::Device`], [`crate::vk::Extent2D`], [`crate::vk::RenderPass`]\n"]
#[allow(non_camel_case_types)]
pub type PFN_vkGetDeviceSubpassShadingMaxWorkgroupSizeHUAWEI = unsafe extern "system" fn(device: crate::vk1_0::Device, renderpass: crate::vk1_0::RenderPass, p_max_workgroup_size: *mut crate::vk1_0::Extent2D) -> crate::vk1_0::Result;
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/vkCmdSubpassShadingHUAWEI.html)) · Function <br/> vkCmdSubpassShadingHUAWEI - Dispatch compute work items\n[](#_c_specification)C Specification\n----------\n\nA subpass shading dispatches a compute pipeline work with the work dimension\nof render area of the calling subpass and work groups are partitioned by\nspecified work group size.\nSubpass operations like subpassLoad and subpassLoadMS are allowed to be\nused.\n\nTo record a subpass shading, call:\n\n```\n// Provided by VK_HUAWEI_subpass_shading\nvoid vkCmdSubpassShadingHUAWEI(\n    VkCommandBuffer                             commandBuffer);\n```\n[](#_parameters)Parameters\n----------\n\n* [`Self::command_buffer`] is the command buffer into which the command will be\n  recorded.\n[](#_description)Description\n----------\n\nWhen the command is executed, a global workgroup consisting of ceil (render\narea size / local workgroup size) local workgroups is assembled.\n\nValid Usage\n\n* []() VUID-vkCmdSubpassShadingHUAWEI-magFilter-04553  \n   If a [`crate::vk::Sampler`] created with `magFilter` or `minFilter`equal to [`crate::vk::Filter::LINEAR`] and `compareEnable` equal to[`crate::vk::FALSE`] is used to sample a [`crate::vk::ImageView`] as a result of this\n  command, then the image view’s[format features](#resources-image-view-format-features) **must** contain[`crate::vk::FormatFeatureFlagBits::SAMPLED_IMAGE_FILTER_LINEAR`]\n\n* []() VUID-vkCmdSubpassShadingHUAWEI-mipmapMode-04770  \n   If a [`crate::vk::Sampler`] created with `mipmapMode` equal to[`crate::vk::SamplerMipmapMode::LINEAR`] and `compareEnable` equal to[`crate::vk::FALSE`] is used to sample a [`crate::vk::ImageView`] as a result of this\n  command, then the image view’s[format features](#resources-image-view-format-features) **must** contain[`crate::vk::FormatFeatureFlagBits::SAMPLED_IMAGE_FILTER_LINEAR`]\n\n* []() VUID-vkCmdSubpassShadingHUAWEI-None-02691  \n   If a [`crate::vk::ImageView`] is accessed using atomic operations as a result\n  of this command, then the image view’s[format features](#resources-image-view-format-features) **must** contain[`crate::vk::FormatFeatureFlagBits::STORAGE_IMAGE_ATOMIC`]\n\n* []() VUID-vkCmdSubpassShadingHUAWEI-None-02692  \n   If a [`crate::vk::ImageView`] is sampled with [`crate::vk::Filter::CUBIC_EXT`] as a\n  result of this command, then the image view’s[format features](#resources-image-view-format-features) **must** contain[`crate::vk::FormatFeatureFlagBits::SAMPLED_IMAGE_FILTER_CUBIC_EXT`]\n\n* []() VUID-vkCmdSubpassShadingHUAWEI-filterCubic-02694  \n   Any [`crate::vk::ImageView`] being sampled with [`crate::vk::Filter::CUBIC_EXT`] as a\n  result of this command **must** have a [`crate::vk::ImageViewType`] and format\n  that supports cubic filtering, as specified by[`crate::vk::FilterCubicImageViewImageFormatPropertiesEXT`]::`filterCubic`returned by [`crate::vk::PFN_vkGetPhysicalDeviceImageFormatProperties2`]\n\n* []() VUID-vkCmdSubpassShadingHUAWEI-filterCubicMinmax-02695  \n   Any [`crate::vk::ImageView`] being sampled with [`crate::vk::Filter::CUBIC_EXT`] with\n  a reduction mode of either [`crate::vk::SamplerReductionMode::MIN`] or[`crate::vk::SamplerReductionMode::MAX`] as a result of this command **must**have a [`crate::vk::ImageViewType`] and format that supports cubic filtering\n  together with minmax filtering, as specified by[`crate::vk::FilterCubicImageViewImageFormatPropertiesEXT`]::`filterCubicMinmax`returned by [`crate::vk::PFN_vkGetPhysicalDeviceImageFormatProperties2`]\n\n* []() VUID-vkCmdSubpassShadingHUAWEI-flags-02696  \n   Any [`crate::vk::Image`] created with a [`crate::vk::ImageCreateInfo::flags`]containing [`crate::vk::ImageCreateFlagBits::CORNER_SAMPLED_NV`] sampled as a\n  result of this command **must** only be sampled using a[`crate::vk::SamplerAddressMode`] of[`crate::vk::SamplerAddressMode::CLAMP_TO_EDGE`]\n\n* []() VUID-vkCmdSubpassShadingHUAWEI-None-02697  \n   For each set *n* that is statically used by the [`crate::vk::Pipeline`] bound\n  to the pipeline bind point used by this command, a descriptor set **must**have been bound to *n* at the same pipeline bind point, with a[`crate::vk::PipelineLayout`] that is compatible for set *n*, with the[`crate::vk::PipelineLayout`] used to create the current [`crate::vk::Pipeline`], as\n  described in [[descriptorsets-compatibility]](#descriptorsets-compatibility)\n\n* []() VUID-vkCmdSubpassShadingHUAWEI-None-02698  \n   For each push constant that is statically used by the [`crate::vk::Pipeline`]bound to the pipeline bind point used by this command, a push constant\n  value **must** have been set for the same pipeline bind point, with a[`crate::vk::PipelineLayout`] that is compatible for push constants, with the[`crate::vk::PipelineLayout`] used to create the current [`crate::vk::Pipeline`], as\n  described in [[descriptorsets-compatibility]](#descriptorsets-compatibility)\n\n* []() VUID-vkCmdSubpassShadingHUAWEI-None-02699  \n   Descriptors in each bound descriptor set, specified via[`crate::vk::PFN_vkCmdBindDescriptorSets`], **must** be valid if they are statically\n  used by the [`crate::vk::Pipeline`] bound to the pipeline bind point used by\n  this command\n\n* []() VUID-vkCmdSubpassShadingHUAWEI-None-02700  \n   A valid pipeline **must** be bound to the pipeline bind point used by this\n  command\n\n* []() VUID-vkCmdSubpassShadingHUAWEI-commandBuffer-02701  \n   If the [`crate::vk::Pipeline`] object bound to the pipeline bind point used by\n  this command requires any dynamic state, that state **must** have been set\n  or inherited (if the `[[VK_NV_inherited_viewport_scissor]](#VK_NV_inherited_viewport_scissor)` extension is\n  enabled) for [`Self::command_buffer`], and done so after any previously bound\n  pipeline with the corresponding state not specified as dynamic\n\n* []() VUID-vkCmdSubpassShadingHUAWEI-None-02859  \n   There **must** not have been any calls to dynamic state setting commands\n  for any state not specified as dynamic in the [`crate::vk::Pipeline`] object\n  bound to the pipeline bind point used by this command, since that\n  pipeline was bound\n\n* []() VUID-vkCmdSubpassShadingHUAWEI-None-02702  \n   If the [`crate::vk::Pipeline`] object bound to the pipeline bind point used by\n  this command accesses a [`crate::vk::Sampler`] object that uses unnormalized\n  coordinates, that sampler **must** not be used to sample from any[`crate::vk::Image`] with a [`crate::vk::ImageView`] of the type[`crate::vk::ImageViewType::_3D`], [`crate::vk::ImageViewType::CUBE`],[`crate::vk::ImageViewType::_1D_ARRAY`], [`crate::vk::ImageViewType::_2D_ARRAY`] or[`crate::vk::ImageViewType::CUBE_ARRAY`], in any shader stage\n\n* []() VUID-vkCmdSubpassShadingHUAWEI-None-02703  \n   If the [`crate::vk::Pipeline`] object bound to the pipeline bind point used by\n  this command accesses a [`crate::vk::Sampler`] object that uses unnormalized\n  coordinates, that sampler **must** not be used with any of the SPIR-V`OpImageSample*` or `OpImageSparseSample*` instructions with`ImplicitLod`, `Dref` or `Proj` in their name, in any shader\n  stage\n\n* []() VUID-vkCmdSubpassShadingHUAWEI-None-02704  \n   If the [`crate::vk::Pipeline`] object bound to the pipeline bind point used by\n  this command accesses a [`crate::vk::Sampler`] object that uses unnormalized\n  coordinates, that sampler **must** not be used with any of the SPIR-V`OpImageSample*` or `OpImageSparseSample*` instructions that includes a\n  LOD bias or any offset values, in any shader stage\n\n* []() VUID-vkCmdSubpassShadingHUAWEI-None-02705  \n   If the [robust buffer access](#features-robustBufferAccess) feature is\n  not enabled, and if the [`crate::vk::Pipeline`] object bound to the pipeline\n  bind point used by this command accesses a uniform buffer, it **must** not\n  access values outside of the range of the buffer as specified in the\n  descriptor set bound to the same pipeline bind point\n\n* []() VUID-vkCmdSubpassShadingHUAWEI-None-02706  \n   If the [robust buffer access](#features-robustBufferAccess) feature is\n  not enabled, and if the [`crate::vk::Pipeline`] object bound to the pipeline\n  bind point used by this command accesses a storage buffer, it **must** not\n  access values outside of the range of the buffer as specified in the\n  descriptor set bound to the same pipeline bind point\n\n* []() VUID-vkCmdSubpassShadingHUAWEI-commandBuffer-02707  \n   If [`Self::command_buffer`] is an unprotected command buffer, any resource\n  accessed by the [`crate::vk::Pipeline`] object bound to the pipeline bind point\n  used by this command **must** not be a protected resource\n\n* []() VUID-vkCmdSubpassShadingHUAWEI-None-04115  \n   If a [`crate::vk::ImageView`] is accessed using `OpImageWrite` as a result\n  of this command, then the `Type` of the `Texel` operand of that\n  instruction **must** have at least as many components as the image view’s\n  format.\n\n* []() VUID-vkCmdSubpassShadingHUAWEI-OpImageWrite-04469  \n   If a [`crate::vk::BufferView`] is accessed using `OpImageWrite` as a result\n  of this command, then the `Type` of the `Texel` operand of that\n  instruction **must** have at least as many components as the buffer view’s\n  format.\n\n* []() VUID-vkCmdSubpassShadingHUAWEI-SampledType-04470  \n   If a [`crate::vk::ImageView`] with a [`crate::vk::Format`] that has a 64-bit channel\n  width is accessed as a result of this command, the `SampledType` of\n  the `OpTypeImage` operand of that instruction **must** have a `Width`of 64.\n\n* []() VUID-vkCmdSubpassShadingHUAWEI-SampledType-04471  \n   If a [`crate::vk::ImageView`] with a [`crate::vk::Format`] that has a channel width\n  less than 64-bit is accessed as a result of this command, the`SampledType` of the `OpTypeImage` operand of that instruction**must** have a `Width` of 32.\n\n* []() VUID-vkCmdSubpassShadingHUAWEI-SampledType-04472  \n   If a [`crate::vk::BufferView`] with a [`crate::vk::Format`] that has a 64-bit channel\n  width is accessed as a result of this command, the `SampledType` of\n  the `OpTypeImage` operand of that instruction **must** have a `Width`of 64.\n\n* []() VUID-vkCmdSubpassShadingHUAWEI-SampledType-04473  \n   If a [`crate::vk::BufferView`] with a [`crate::vk::Format`] that has a channel width\n  less than 64-bit is accessed as a result of this command, the`SampledType` of the `OpTypeImage` operand of that instruction**must** have a `Width` of 32.\n\n* []() VUID-vkCmdSubpassShadingHUAWEI-sparseImageInt64Atomics-04474  \n   If the[`sparseImageInt64Atomics`](#features-sparseImageInt64Atomics)feature is not enabled, [`crate::vk::Image`] objects created with the[`crate::vk::ImageCreateFlagBits::SPARSE_RESIDENCY`] flag **must** not be accessed by\n  atomic instructions through an `OpTypeImage` with a `SampledType`with a `Width` of 64 by this command.\n\n* []() VUID-vkCmdSubpassShadingHUAWEI-sparseImageInt64Atomics-04475  \n   If the[`sparseImageInt64Atomics`](#features-sparseImageInt64Atomics)feature is not enabled, [`crate::vk::Buffer`] objects created with the[`crate::vk::BufferCreateFlagBits::SPARSE_RESIDENCY`] flag **must** not be accessed\n  by atomic instructions through an `OpTypeImage` with a`SampledType` with a `Width` of 64 by this command.\n\n* []() VUID-vkCmdSubpassShadingHUAWEI-None-04931  \n   This command must be called in a subpass with bind point\n  VK\\_PIPELINE\\_BIND\\_POINT\\_SUBPASS\\_SHADING\\_HUAWEI.\n  No draw commands can be called in the same subpass.\n  Only one vkCmdSubpassShadingHUAWEI command can be called in a subpass.\n\nValid Usage (Implicit)\n\n* []() VUID-vkCmdSubpassShadingHUAWEI-commandBuffer-parameter  \n  [`Self::command_buffer`] **must** be a valid [`crate::vk::CommandBuffer`] handle\n\n* []() VUID-vkCmdSubpassShadingHUAWEI-commandBuffer-recording  \n  [`Self::command_buffer`] **must** be in the [recording state](#commandbuffers-lifecycle)\n\n* []() VUID-vkCmdSubpassShadingHUAWEI-commandBuffer-cmdpool  \n   The [`crate::vk::CommandPool`] that [`Self::command_buffer`] was allocated from **must** support graphics operations\n\n* []() VUID-vkCmdSubpassShadingHUAWEI-renderpass  \n   This command **must** only be called inside of a render pass instance\n\nHost Synchronization\n\n* Host access to [`Self::command_buffer`] **must** be externally synchronized\n\n* Host access to the [`crate::vk::CommandPool`] that [`Self::command_buffer`] was allocated from **must** be externally synchronized\n\nCommand Properties\n\n|[Command Buffer Levels](#VkCommandBufferLevel)|[Render Pass Scope](#vkCmdBeginRenderPass)|[Supported Queue Types](#VkQueueFlagBits)|\n|----------------------------------------------|------------------------------------------|-----------------------------------------|\n|           Primary  <br/>Secondary            |                  Inside                  |                Graphics                 |\n[](#_see_also)See Also\n----------\n\n[`crate::vk::CommandBuffer`]\n"]
#[allow(non_camel_case_types)]
pub type PFN_vkCmdSubpassShadingHUAWEI = unsafe extern "system" fn(command_buffer: crate::vk1_0::CommandBuffer) -> ();
impl<'a> crate::ExtendableFromConst<'a, PhysicalDeviceSubpassShadingFeaturesHUAWEI> for crate::vk1_0::DeviceCreateInfoBuilder<'a> {}
impl<'a> crate::ExtendableFromConst<'a, PhysicalDeviceSubpassShadingFeaturesHUAWEIBuilder<'_>> for crate::vk1_0::DeviceCreateInfoBuilder<'a> {}
impl<'a> crate::ExtendableFromConst<'a, SubpassShadingPipelineCreateInfoHUAWEI> for crate::vk1_0::ComputePipelineCreateInfoBuilder<'a> {}
impl<'a> crate::ExtendableFromConst<'a, SubpassShadingPipelineCreateInfoHUAWEIBuilder<'_>> for crate::vk1_0::ComputePipelineCreateInfoBuilder<'a> {}
impl<'a> crate::ExtendableFromMut<'a, PhysicalDeviceSubpassShadingFeaturesHUAWEI> for crate::vk1_1::PhysicalDeviceFeatures2Builder<'a> {}
impl<'a> crate::ExtendableFromMut<'a, PhysicalDeviceSubpassShadingFeaturesHUAWEIBuilder<'_>> for crate::vk1_1::PhysicalDeviceFeatures2Builder<'a> {}
impl<'a> crate::ExtendableFromMut<'a, PhysicalDeviceSubpassShadingPropertiesHUAWEI> for crate::vk1_1::PhysicalDeviceProperties2Builder<'a> {}
impl<'a> crate::ExtendableFromMut<'a, PhysicalDeviceSubpassShadingPropertiesHUAWEIBuilder<'_>> for crate::vk1_1::PhysicalDeviceProperties2Builder<'a> {}
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkSubpassShadingPipelineCreateInfoHUAWEI.html)) · Structure <br/> VkSubpassShadingPipelineCreateInfoHUAWEI - Structure specifying parameters of a newly created subpass shading pipeline\n[](#_c_specification)C Specification\n----------\n\nA subpass shading pipeline is a compute pipeline which **must** be called only\nin a subpass of a render pass with work dimensions specified by render area\nsize.\nThe subpass shading pipeline shader is a compute shader allowed to access\ninput attachments specified in the calling subpass.\nTo create a subpass shading pipeline, call [`crate::vk::PFN_vkCreateComputePipelines`]with [`crate::vk::SubpassShadingPipelineCreateInfoHUAWEI`] in the [`Self::p_next`] chain\nof [`crate::vk::ComputePipelineCreateInfo`].\n\nThe [`crate::vk::SubpassShadingPipelineCreateInfoHUAWEI`] structure is defined as:\n\n```\n// Provided by VK_HUAWEI_subpass_shading\ntypedef struct VkSubpassShadingPipelineCreateInfoHUAWEI {\n    VkStructureType    sType;\n    void*              pNext;\n    VkRenderPass       renderPass;\n    uint32_t           subpass;\n} VkSubpassShadingPipelineCreateInfoHUAWEI;\n```\n[](#_members)Members\n----------\n\n* [`Self::s_type`] is the type of this structure.\n\n* [`Self::p_next`] is `NULL` or a pointer to a structure extending this\n  structure.\n\n* [`Self::render_pass`] is a handle to a render pass object describing the\n  environment in which the pipeline will be used; the pipeline **must** only\n  be used with an instance of any render pass compatible with the one\n  provided.\n  See [Render Pass Compatibility](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/html/vkspec.html#renderpass-compatibility) for more\n  information.\n\n* [`Self::subpass`] is the index of the subpass in the render pass where this\n  pipeline will be used.\n[](#_description)Description\n----------\n\nValid Usage\n\n* []() VUID-VkSubpassShadingPipelineCreateInfoHUAWEI-subpass-04946  \n  [`Self::subpass`] **must** be created with\n  VK\\_PIPELINE\\_BIND\\_POINT\\_SUBPASS\\_SHADING\\_HUAWEI bind point.\n\nValid Usage (Implicit)\n\n* []() VUID-VkSubpassShadingPipelineCreateInfoHUAWEI-sType-sType  \n  [`Self::s_type`] **must** be [`crate::vk::StructureType::SUBPASS_SHADING_PIPELINE_CREATE_INFO_HUAWEI`]\n[](#_see_also)See Also\n----------\n\n[`crate::vk::RenderPass`], [`crate::vk::StructureType`]\n"]
#[doc(alias = "VkSubpassShadingPipelineCreateInfoHUAWEI")]
#[derive(Copy, Clone)]
#[repr(C)]
pub struct SubpassShadingPipelineCreateInfoHUAWEI {
    pub s_type: crate::vk1_0::StructureType,
    pub p_next: *mut std::ffi::c_void,
    pub render_pass: crate::vk1_0::RenderPass,
    pub subpass: u32,
}
impl SubpassShadingPipelineCreateInfoHUAWEI {
    pub const STRUCTURE_TYPE: crate::vk1_0::StructureType = crate::vk1_0::StructureType::SUBPASS_SHADING_PIPELINE_CREATE_INFO_HUAWEI;
}
impl Default for SubpassShadingPipelineCreateInfoHUAWEI {
    fn default() -> Self {
        Self { s_type: Self::STRUCTURE_TYPE, p_next: std::ptr::null_mut(), render_pass: Default::default(), subpass: Default::default() }
    }
}
impl std::fmt::Debug for SubpassShadingPipelineCreateInfoHUAWEI {
    fn fmt(&self, f: &mut std::fmt::Formatter) -> std::fmt::Result {
        f.debug_struct("SubpassShadingPipelineCreateInfoHUAWEI").field("s_type", &self.s_type).field("p_next", &self.p_next).field("render_pass", &self.render_pass).field("subpass", &self.subpass).finish()
    }
}
impl SubpassShadingPipelineCreateInfoHUAWEI {
    #[inline]
    pub fn into_builder<'a>(self) -> SubpassShadingPipelineCreateInfoHUAWEIBuilder<'a> {
        SubpassShadingPipelineCreateInfoHUAWEIBuilder(self, std::marker::PhantomData)
    }
}
#[derive(Copy, Clone)]
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkSubpassShadingPipelineCreateInfoHUAWEI.html)) · Builder of [`SubpassShadingPipelineCreateInfoHUAWEI`] <br/> VkSubpassShadingPipelineCreateInfoHUAWEI - Structure specifying parameters of a newly created subpass shading pipeline\n[](#_c_specification)C Specification\n----------\n\nA subpass shading pipeline is a compute pipeline which **must** be called only\nin a subpass of a render pass with work dimensions specified by render area\nsize.\nThe subpass shading pipeline shader is a compute shader allowed to access\ninput attachments specified in the calling subpass.\nTo create a subpass shading pipeline, call [`crate::vk::PFN_vkCreateComputePipelines`]with [`crate::vk::SubpassShadingPipelineCreateInfoHUAWEI`] in the [`Self::p_next`] chain\nof [`crate::vk::ComputePipelineCreateInfo`].\n\nThe [`crate::vk::SubpassShadingPipelineCreateInfoHUAWEI`] structure is defined as:\n\n```\n// Provided by VK_HUAWEI_subpass_shading\ntypedef struct VkSubpassShadingPipelineCreateInfoHUAWEI {\n    VkStructureType    sType;\n    void*              pNext;\n    VkRenderPass       renderPass;\n    uint32_t           subpass;\n} VkSubpassShadingPipelineCreateInfoHUAWEI;\n```\n[](#_members)Members\n----------\n\n* [`Self::s_type`] is the type of this structure.\n\n* [`Self::p_next`] is `NULL` or a pointer to a structure extending this\n  structure.\n\n* [`Self::render_pass`] is a handle to a render pass object describing the\n  environment in which the pipeline will be used; the pipeline **must** only\n  be used with an instance of any render pass compatible with the one\n  provided.\n  See [Render Pass Compatibility](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/html/vkspec.html#renderpass-compatibility) for more\n  information.\n\n* [`Self::subpass`] is the index of the subpass in the render pass where this\n  pipeline will be used.\n[](#_description)Description\n----------\n\nValid Usage\n\n* []() VUID-VkSubpassShadingPipelineCreateInfoHUAWEI-subpass-04946  \n  [`Self::subpass`] **must** be created with\n  VK\\_PIPELINE\\_BIND\\_POINT\\_SUBPASS\\_SHADING\\_HUAWEI bind point.\n\nValid Usage (Implicit)\n\n* []() VUID-VkSubpassShadingPipelineCreateInfoHUAWEI-sType-sType  \n  [`Self::s_type`] **must** be [`crate::vk::StructureType::SUBPASS_SHADING_PIPELINE_CREATE_INFO_HUAWEI`]\n[](#_see_also)See Also\n----------\n\n[`crate::vk::RenderPass`], [`crate::vk::StructureType`]\n"]
#[repr(transparent)]
pub struct SubpassShadingPipelineCreateInfoHUAWEIBuilder<'a>(SubpassShadingPipelineCreateInfoHUAWEI, std::marker::PhantomData<&'a ()>);
impl<'a> SubpassShadingPipelineCreateInfoHUAWEIBuilder<'a> {
    #[inline]
    pub fn new() -> SubpassShadingPipelineCreateInfoHUAWEIBuilder<'a> {
        SubpassShadingPipelineCreateInfoHUAWEIBuilder(Default::default(), std::marker::PhantomData)
    }
    #[inline]
    pub fn render_pass(mut self, render_pass: crate::vk1_0::RenderPass) -> Self {
        self.0.render_pass = render_pass as _;
        self
    }
    #[inline]
    pub fn subpass(mut self, subpass: u32) -> Self {
        self.0.subpass = subpass as _;
        self
    }
    #[inline]
    #[doc = r" Discards all lifetime information."]
    #[doc = r" Use the `Deref` and `DerefMut` implementations if possible."]
    pub fn build(self) -> SubpassShadingPipelineCreateInfoHUAWEI {
        self.0
    }
}
impl<'a> std::default::Default for SubpassShadingPipelineCreateInfoHUAWEIBuilder<'a> {
    fn default() -> SubpassShadingPipelineCreateInfoHUAWEIBuilder<'a> {
        Self::new()
    }
}
impl<'a> std::fmt::Debug for SubpassShadingPipelineCreateInfoHUAWEIBuilder<'a> {
    fn fmt(&self, f: &mut std::fmt::Formatter) -> std::fmt::Result {
        std::fmt::Debug::fmt(&self.0, f)
    }
}
impl<'a> std::ops::Deref for SubpassShadingPipelineCreateInfoHUAWEIBuilder<'a> {
    type Target = SubpassShadingPipelineCreateInfoHUAWEI;
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl<'a> std::ops::DerefMut for SubpassShadingPipelineCreateInfoHUAWEIBuilder<'a> {
    fn deref_mut(&mut self) -> &mut Self::Target {
        &mut self.0
    }
}
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkPhysicalDeviceSubpassShadingPropertiesHUAWEI.html)) · Structure <br/> VkPhysicalDeviceSubpassShadingPropertiesHUAWEI - Structure describing subpass shading properties supported by an implementation\n[](#_c_specification)C Specification\n----------\n\nThe [`crate::vk::PhysicalDeviceSubpassShadingPropertiesHUAWEI`] structure is\ndefined as:\n\n```\n// Provided by VK_HUAWEI_subpass_shading\ntypedef struct VkPhysicalDeviceSubpassShadingPropertiesHUAWEI {\n    VkStructureType    sType;\n    void*              pNext;\n    uint32_t           maxSubpassShadingWorkgroupSizeAspectRatio;\n} VkPhysicalDeviceSubpassShadingPropertiesHUAWEI;\n```\n[](#_members)Members\n----------\n\n* [`Self::s_type`] is the type of this structure.\n\n* [`Self::p_next`] is `NULL` or a pointer to a structure extending this\n  structure.\n\n* []()[`Self::max_subpass_shading_workgroup_size_aspect_ratio`] indicates the maximum\n  ratio between the width and height of the portion of the subpass shading\n  shader workgroup size.[`Self::max_subpass_shading_workgroup_size_aspect_ratio`] **must** be a power-of-two\n  value, and **must** be less than or equal to max(`WorkgroupSize.x` /`WorkgroupSize.y`, `WorkgroupSize.y` / `WorkgroupSize.x`).\n[](#_description)Description\n----------\n\nIf the [`crate::vk::PhysicalDeviceSubpassShadingPropertiesHUAWEI`] structure is included in the [`Self::p_next`] chain of the[`crate::vk::PhysicalDeviceProperties2`] structure passed to[`crate::vk::PFN_vkGetPhysicalDeviceProperties2`], it is filled in with each\ncorresponding implementation-dependent property.\n\nValid Usage (Implicit)\n\n* []() VUID-VkPhysicalDeviceSubpassShadingPropertiesHUAWEI-sType-sType  \n  [`Self::s_type`] **must** be [`crate::vk::StructureType::PHYSICAL_DEVICE_SUBPASS_SHADING_PROPERTIES_HUAWEI`]\n[](#_see_also)See Also\n----------\n\n[`crate::vk::StructureType`]\n"]
#[doc(alias = "VkPhysicalDeviceSubpassShadingPropertiesHUAWEI")]
#[derive(Copy, Clone)]
#[repr(C)]
pub struct PhysicalDeviceSubpassShadingPropertiesHUAWEI {
    pub s_type: crate::vk1_0::StructureType,
    pub p_next: *mut std::ffi::c_void,
    pub max_subpass_shading_workgroup_size_aspect_ratio: u32,
}
impl PhysicalDeviceSubpassShadingPropertiesHUAWEI {
    pub const STRUCTURE_TYPE: crate::vk1_0::StructureType = crate::vk1_0::StructureType::PHYSICAL_DEVICE_SUBPASS_SHADING_PROPERTIES_HUAWEI;
}
impl Default for PhysicalDeviceSubpassShadingPropertiesHUAWEI {
    fn default() -> Self {
        Self { s_type: Self::STRUCTURE_TYPE, p_next: std::ptr::null_mut(), max_subpass_shading_workgroup_size_aspect_ratio: Default::default() }
    }
}
impl std::fmt::Debug for PhysicalDeviceSubpassShadingPropertiesHUAWEI {
    fn fmt(&self, f: &mut std::fmt::Formatter) -> std::fmt::Result {
        f.debug_struct("PhysicalDeviceSubpassShadingPropertiesHUAWEI").field("s_type", &self.s_type).field("p_next", &self.p_next).field("max_subpass_shading_workgroup_size_aspect_ratio", &self.max_subpass_shading_workgroup_size_aspect_ratio).finish()
    }
}
impl PhysicalDeviceSubpassShadingPropertiesHUAWEI {
    #[inline]
    pub fn into_builder<'a>(self) -> PhysicalDeviceSubpassShadingPropertiesHUAWEIBuilder<'a> {
        PhysicalDeviceSubpassShadingPropertiesHUAWEIBuilder(self, std::marker::PhantomData)
    }
}
#[derive(Copy, Clone)]
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkPhysicalDeviceSubpassShadingPropertiesHUAWEI.html)) · Builder of [`PhysicalDeviceSubpassShadingPropertiesHUAWEI`] <br/> VkPhysicalDeviceSubpassShadingPropertiesHUAWEI - Structure describing subpass shading properties supported by an implementation\n[](#_c_specification)C Specification\n----------\n\nThe [`crate::vk::PhysicalDeviceSubpassShadingPropertiesHUAWEI`] structure is\ndefined as:\n\n```\n// Provided by VK_HUAWEI_subpass_shading\ntypedef struct VkPhysicalDeviceSubpassShadingPropertiesHUAWEI {\n    VkStructureType    sType;\n    void*              pNext;\n    uint32_t           maxSubpassShadingWorkgroupSizeAspectRatio;\n} VkPhysicalDeviceSubpassShadingPropertiesHUAWEI;\n```\n[](#_members)Members\n----------\n\n* [`Self::s_type`] is the type of this structure.\n\n* [`Self::p_next`] is `NULL` or a pointer to a structure extending this\n  structure.\n\n* []()[`Self::max_subpass_shading_workgroup_size_aspect_ratio`] indicates the maximum\n  ratio between the width and height of the portion of the subpass shading\n  shader workgroup size.[`Self::max_subpass_shading_workgroup_size_aspect_ratio`] **must** be a power-of-two\n  value, and **must** be less than or equal to max(`WorkgroupSize.x` /`WorkgroupSize.y`, `WorkgroupSize.y` / `WorkgroupSize.x`).\n[](#_description)Description\n----------\n\nIf the [`crate::vk::PhysicalDeviceSubpassShadingPropertiesHUAWEI`] structure is included in the [`Self::p_next`] chain of the[`crate::vk::PhysicalDeviceProperties2`] structure passed to[`crate::vk::PFN_vkGetPhysicalDeviceProperties2`], it is filled in with each\ncorresponding implementation-dependent property.\n\nValid Usage (Implicit)\n\n* []() VUID-VkPhysicalDeviceSubpassShadingPropertiesHUAWEI-sType-sType  \n  [`Self::s_type`] **must** be [`crate::vk::StructureType::PHYSICAL_DEVICE_SUBPASS_SHADING_PROPERTIES_HUAWEI`]\n[](#_see_also)See Also\n----------\n\n[`crate::vk::StructureType`]\n"]
#[repr(transparent)]
pub struct PhysicalDeviceSubpassShadingPropertiesHUAWEIBuilder<'a>(PhysicalDeviceSubpassShadingPropertiesHUAWEI, std::marker::PhantomData<&'a ()>);
impl<'a> PhysicalDeviceSubpassShadingPropertiesHUAWEIBuilder<'a> {
    #[inline]
    pub fn new() -> PhysicalDeviceSubpassShadingPropertiesHUAWEIBuilder<'a> {
        PhysicalDeviceSubpassShadingPropertiesHUAWEIBuilder(Default::default(), std::marker::PhantomData)
    }
    #[inline]
    pub fn max_subpass_shading_workgroup_size_aspect_ratio(mut self, max_subpass_shading_workgroup_size_aspect_ratio: u32) -> Self {
        self.0.max_subpass_shading_workgroup_size_aspect_ratio = max_subpass_shading_workgroup_size_aspect_ratio as _;
        self
    }
    #[inline]
    #[doc = r" Discards all lifetime information."]
    #[doc = r" Use the `Deref` and `DerefMut` implementations if possible."]
    pub fn build(self) -> PhysicalDeviceSubpassShadingPropertiesHUAWEI {
        self.0
    }
}
impl<'a> std::default::Default for PhysicalDeviceSubpassShadingPropertiesHUAWEIBuilder<'a> {
    fn default() -> PhysicalDeviceSubpassShadingPropertiesHUAWEIBuilder<'a> {
        Self::new()
    }
}
impl<'a> std::fmt::Debug for PhysicalDeviceSubpassShadingPropertiesHUAWEIBuilder<'a> {
    fn fmt(&self, f: &mut std::fmt::Formatter) -> std::fmt::Result {
        std::fmt::Debug::fmt(&self.0, f)
    }
}
impl<'a> std::ops::Deref for PhysicalDeviceSubpassShadingPropertiesHUAWEIBuilder<'a> {
    type Target = PhysicalDeviceSubpassShadingPropertiesHUAWEI;
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl<'a> std::ops::DerefMut for PhysicalDeviceSubpassShadingPropertiesHUAWEIBuilder<'a> {
    fn deref_mut(&mut self) -> &mut Self::Target {
        &mut self.0
    }
}
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkPhysicalDeviceSubpassShadingFeaturesHUAWEI.html)) · Structure <br/> VkPhysicalDeviceSubpassShadingFeaturesHUAWEI - Structure describing whether subpass shading is enabled\n[](#_c_specification)C Specification\n----------\n\nThe [`crate::vk::PhysicalDeviceSubpassShadingFeaturesHUAWEI`] structure is defined\nas:\n\n```\n// Provided by VK_HUAWEI_subpass_shading\ntypedef struct VkPhysicalDeviceSubpassShadingFeaturesHUAWEI {\n    VkStructureType    sType;\n    void*              pNext;\n    VkBool32           subpassShading;\n} VkPhysicalDeviceSubpassShadingFeaturesHUAWEI;\n```\n[](#_members)Members\n----------\n\nIf the [`crate::vk::PhysicalDeviceSubpassShadingFeaturesHUAWEI`] structure is included in the [`Self::p_next`] chain of the[`crate::vk::PhysicalDeviceFeatures2`] structure passed to[`crate::vk::PFN_vkGetPhysicalDeviceFeatures2`], it is filled in to indicate whether each\ncorresponding feature is supported.[`crate::vk::PhysicalDeviceSubpassShadingFeaturesHUAWEI`] **can** also be used in the [`Self::p_next`] chain of[`crate::vk::DeviceCreateInfo`] to selectively enable these features.\n[](#_description)Description\n----------\n\nValid Usage (Implicit)\n\n* []() VUID-VkPhysicalDeviceSubpassShadingFeaturesHUAWEI-sType-sType  \n  [`Self::s_type`] **must** be [`crate::vk::StructureType::PHYSICAL_DEVICE_SUBPASS_SHADING_FEATURES_HUAWEI`]\n[](#_see_also)See Also\n----------\n\n[`crate::vk::Bool32`], [`crate::vk::StructureType`]\n"]
#[doc(alias = "VkPhysicalDeviceSubpassShadingFeaturesHUAWEI")]
#[derive(Copy, Clone)]
#[repr(C)]
pub struct PhysicalDeviceSubpassShadingFeaturesHUAWEI {
    pub s_type: crate::vk1_0::StructureType,
    pub p_next: *mut std::ffi::c_void,
    pub subpass_shading: crate::vk1_0::Bool32,
}
impl PhysicalDeviceSubpassShadingFeaturesHUAWEI {
    pub const STRUCTURE_TYPE: crate::vk1_0::StructureType = crate::vk1_0::StructureType::PHYSICAL_DEVICE_SUBPASS_SHADING_FEATURES_HUAWEI;
}
impl Default for PhysicalDeviceSubpassShadingFeaturesHUAWEI {
    fn default() -> Self {
        Self { s_type: Self::STRUCTURE_TYPE, p_next: std::ptr::null_mut(), subpass_shading: Default::default() }
    }
}
impl std::fmt::Debug for PhysicalDeviceSubpassShadingFeaturesHUAWEI {
    fn fmt(&self, f: &mut std::fmt::Formatter) -> std::fmt::Result {
        f.debug_struct("PhysicalDeviceSubpassShadingFeaturesHUAWEI").field("s_type", &self.s_type).field("p_next", &self.p_next).field("subpass_shading", &(self.subpass_shading != 0)).finish()
    }
}
impl PhysicalDeviceSubpassShadingFeaturesHUAWEI {
    #[inline]
    pub fn into_builder<'a>(self) -> PhysicalDeviceSubpassShadingFeaturesHUAWEIBuilder<'a> {
        PhysicalDeviceSubpassShadingFeaturesHUAWEIBuilder(self, std::marker::PhantomData)
    }
}
#[derive(Copy, Clone)]
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkPhysicalDeviceSubpassShadingFeaturesHUAWEI.html)) · Builder of [`PhysicalDeviceSubpassShadingFeaturesHUAWEI`] <br/> VkPhysicalDeviceSubpassShadingFeaturesHUAWEI - Structure describing whether subpass shading is enabled\n[](#_c_specification)C Specification\n----------\n\nThe [`crate::vk::PhysicalDeviceSubpassShadingFeaturesHUAWEI`] structure is defined\nas:\n\n```\n// Provided by VK_HUAWEI_subpass_shading\ntypedef struct VkPhysicalDeviceSubpassShadingFeaturesHUAWEI {\n    VkStructureType    sType;\n    void*              pNext;\n    VkBool32           subpassShading;\n} VkPhysicalDeviceSubpassShadingFeaturesHUAWEI;\n```\n[](#_members)Members\n----------\n\nIf the [`crate::vk::PhysicalDeviceSubpassShadingFeaturesHUAWEI`] structure is included in the [`Self::p_next`] chain of the[`crate::vk::PhysicalDeviceFeatures2`] structure passed to[`crate::vk::PFN_vkGetPhysicalDeviceFeatures2`], it is filled in to indicate whether each\ncorresponding feature is supported.[`crate::vk::PhysicalDeviceSubpassShadingFeaturesHUAWEI`] **can** also be used in the [`Self::p_next`] chain of[`crate::vk::DeviceCreateInfo`] to selectively enable these features.\n[](#_description)Description\n----------\n\nValid Usage (Implicit)\n\n* []() VUID-VkPhysicalDeviceSubpassShadingFeaturesHUAWEI-sType-sType  \n  [`Self::s_type`] **must** be [`crate::vk::StructureType::PHYSICAL_DEVICE_SUBPASS_SHADING_FEATURES_HUAWEI`]\n[](#_see_also)See Also\n----------\n\n[`crate::vk::Bool32`], [`crate::vk::StructureType`]\n"]
#[repr(transparent)]
pub struct PhysicalDeviceSubpassShadingFeaturesHUAWEIBuilder<'a>(PhysicalDeviceSubpassShadingFeaturesHUAWEI, std::marker::PhantomData<&'a ()>);
impl<'a> PhysicalDeviceSubpassShadingFeaturesHUAWEIBuilder<'a> {
    #[inline]
    pub fn new() -> PhysicalDeviceSubpassShadingFeaturesHUAWEIBuilder<'a> {
        PhysicalDeviceSubpassShadingFeaturesHUAWEIBuilder(Default::default(), std::marker::PhantomData)
    }
    #[inline]
    pub fn subpass_shading(mut self, subpass_shading: bool) -> Self {
        self.0.subpass_shading = subpass_shading as _;
        self
    }
    #[inline]
    #[doc = r" Discards all lifetime information."]
    #[doc = r" Use the `Deref` and `DerefMut` implementations if possible."]
    pub fn build(self) -> PhysicalDeviceSubpassShadingFeaturesHUAWEI {
        self.0
    }
}
impl<'a> std::default::Default for PhysicalDeviceSubpassShadingFeaturesHUAWEIBuilder<'a> {
    fn default() -> PhysicalDeviceSubpassShadingFeaturesHUAWEIBuilder<'a> {
        Self::new()
    }
}
impl<'a> std::fmt::Debug for PhysicalDeviceSubpassShadingFeaturesHUAWEIBuilder<'a> {
    fn fmt(&self, f: &mut std::fmt::Formatter) -> std::fmt::Result {
        std::fmt::Debug::fmt(&self.0, f)
    }
}
impl<'a> std::ops::Deref for PhysicalDeviceSubpassShadingFeaturesHUAWEIBuilder<'a> {
    type Target = PhysicalDeviceSubpassShadingFeaturesHUAWEI;
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl<'a> std::ops::DerefMut for PhysicalDeviceSubpassShadingFeaturesHUAWEIBuilder<'a> {
    fn deref_mut(&mut self) -> &mut Self::Target {
        &mut self.0
    }
}
#[doc = "Provided by [`crate::extensions::huawei_subpass_shading`]"]
impl crate::DeviceLoader {
    #[inline]
    #[track_caller]
    #[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/vkGetDeviceSubpassShadingMaxWorkgroupSizeHUAWEI.html)) · Function <br/> vkGetDeviceSubpassShadingMaxWorkgroupSizeHUAWEI - Query maximum supported subpass shading workgroup size for a give render pass\n[](#_c_specification)C Specification\n----------\n\nA subpass shading pipeline’s workgroup size is a 2D vector with number of\npower-of-two in width and height.\nThe maximum number of width and height is implementation dependent, and **may**vary for different formats and sample counts of attachments in a render\npass.\n\nTo query the maximum workgroup size, call:\n\n```\n// Provided by VK_HUAWEI_subpass_shading\nVkResult vkGetDeviceSubpassShadingMaxWorkgroupSizeHUAWEI(\n    VkDevice                                    device,\n    VkRenderPass                                renderpass,\n    VkExtent2D*                                 pMaxWorkgroupSize);\n```\n[](#_parameters)Parameters\n----------\n\n* [`Self::device`] is a handle to a local device object that was used to\n  create the given render pass.\n\n* `renderPass` is a handle to a render pass object describing the\n  environment in which the pipeline will be used; the pipeline **must** only\n  be used with an instance of any render pass compatible with the one\n  provided.\n  See [Render Pass Compatibility](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/html/vkspec.html#renderpass-compatibility) for more\n  information.\n\n* [`Self::p_max_workgroup_size`] is a pointer to a [`crate::vk::Extent2D`] structure.\n[](#_description)Description\n----------\n\nValid Usage (Implicit)\n\n* []() VUID-vkGetDeviceSubpassShadingMaxWorkgroupSizeHUAWEI-device-parameter  \n  [`Self::device`] **must** be a valid [`crate::vk::Device`] handle\n\n* []() VUID-vkGetDeviceSubpassShadingMaxWorkgroupSizeHUAWEI-renderpass-parameter  \n  [`Self::renderpass`] **must** be a valid [`crate::vk::RenderPass`] handle\n\n* []() VUID-vkGetDeviceSubpassShadingMaxWorkgroupSizeHUAWEI-pMaxWorkgroupSize-parameter  \n  [`Self::p_max_workgroup_size`] **must** be a valid pointer to a [`crate::vk::Extent2D`] structure\n\n* []() VUID-vkGetDeviceSubpassShadingMaxWorkgroupSizeHUAWEI-renderpass-parent  \n  [`Self::renderpass`] **must** have been created, allocated, or retrieved from [`Self::device`]\n\nReturn Codes\n\nOn success, this command returns\n\n* [`crate::vk::Result::SUCCESS`]\n\n* [`crate::vk::Result::INCOMPLETE`]\n\nOn failure, this command returns\n\n* [`crate::vk::Result::ERROR_OUT_OF_HOST_MEMORY`]\n\n* [`crate::vk::Result::ERROR_OUT_OF_DEVICE_MEMORY`]\n\n* [`crate::vk::Result::ERROR_SURFACE_LOST_KHR`]\n[](#_see_also)See Also\n----------\n\n[`crate::vk::Device`], [`crate::vk::Extent2D`], [`crate::vk::RenderPass`]\n"]
    #[doc(alias = "vkGetDeviceSubpassShadingMaxWorkgroupSizeHUAWEI")]
    pub unsafe fn get_device_subpass_shading_max_workgroup_size_huawei(&self, renderpass: crate::vk1_0::RenderPass) -> crate::utils::VulkanResult<crate::vk1_0::Extent2D> {
        let _function = self.get_device_subpass_shading_max_workgroup_size_huawei.expect(crate::NOT_LOADED_MESSAGE);
        let mut max_workgroup_size = Default::default();
        let _return = _function(self.handle, renderpass as _, &mut max_workgroup_size);
        crate::utils::VulkanResult::new(_return, max_workgroup_size)
    }
    #[inline]
    #[track_caller]
    #[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/vkCmdSubpassShadingHUAWEI.html)) · Function <br/> vkCmdSubpassShadingHUAWEI - Dispatch compute work items\n[](#_c_specification)C Specification\n----------\n\nA subpass shading dispatches a compute pipeline work with the work dimension\nof render area of the calling subpass and work groups are partitioned by\nspecified work group size.\nSubpass operations like subpassLoad and subpassLoadMS are allowed to be\nused.\n\nTo record a subpass shading, call:\n\n```\n// Provided by VK_HUAWEI_subpass_shading\nvoid vkCmdSubpassShadingHUAWEI(\n    VkCommandBuffer                             commandBuffer);\n```\n[](#_parameters)Parameters\n----------\n\n* [`Self::command_buffer`] is the command buffer into which the command will be\n  recorded.\n[](#_description)Description\n----------\n\nWhen the command is executed, a global workgroup consisting of ceil (render\narea size / local workgroup size) local workgroups is assembled.\n\nValid Usage\n\n* []() VUID-vkCmdSubpassShadingHUAWEI-magFilter-04553  \n   If a [`crate::vk::Sampler`] created with `magFilter` or `minFilter`equal to [`crate::vk::Filter::LINEAR`] and `compareEnable` equal to[`crate::vk::FALSE`] is used to sample a [`crate::vk::ImageView`] as a result of this\n  command, then the image view’s[format features](#resources-image-view-format-features) **must** contain[`crate::vk::FormatFeatureFlagBits::SAMPLED_IMAGE_FILTER_LINEAR`]\n\n* []() VUID-vkCmdSubpassShadingHUAWEI-mipmapMode-04770  \n   If a [`crate::vk::Sampler`] created with `mipmapMode` equal to[`crate::vk::SamplerMipmapMode::LINEAR`] and `compareEnable` equal to[`crate::vk::FALSE`] is used to sample a [`crate::vk::ImageView`] as a result of this\n  command, then the image view’s[format features](#resources-image-view-format-features) **must** contain[`crate::vk::FormatFeatureFlagBits::SAMPLED_IMAGE_FILTER_LINEAR`]\n\n* []() VUID-vkCmdSubpassShadingHUAWEI-None-02691  \n   If a [`crate::vk::ImageView`] is accessed using atomic operations as a result\n  of this command, then the image view’s[format features](#resources-image-view-format-features) **must** contain[`crate::vk::FormatFeatureFlagBits::STORAGE_IMAGE_ATOMIC`]\n\n* []() VUID-vkCmdSubpassShadingHUAWEI-None-02692  \n   If a [`crate::vk::ImageView`] is sampled with [`crate::vk::Filter::CUBIC_EXT`] as a\n  result of this command, then the image view’s[format features](#resources-image-view-format-features) **must** contain[`crate::vk::FormatFeatureFlagBits::SAMPLED_IMAGE_FILTER_CUBIC_EXT`]\n\n* []() VUID-vkCmdSubpassShadingHUAWEI-filterCubic-02694  \n   Any [`crate::vk::ImageView`] being sampled with [`crate::vk::Filter::CUBIC_EXT`] as a\n  result of this command **must** have a [`crate::vk::ImageViewType`] and format\n  that supports cubic filtering, as specified by[`crate::vk::FilterCubicImageViewImageFormatPropertiesEXT`]::`filterCubic`returned by [`crate::vk::PFN_vkGetPhysicalDeviceImageFormatProperties2`]\n\n* []() VUID-vkCmdSubpassShadingHUAWEI-filterCubicMinmax-02695  \n   Any [`crate::vk::ImageView`] being sampled with [`crate::vk::Filter::CUBIC_EXT`] with\n  a reduction mode of either [`crate::vk::SamplerReductionMode::MIN`] or[`crate::vk::SamplerReductionMode::MAX`] as a result of this command **must**have a [`crate::vk::ImageViewType`] and format that supports cubic filtering\n  together with minmax filtering, as specified by[`crate::vk::FilterCubicImageViewImageFormatPropertiesEXT`]::`filterCubicMinmax`returned by [`crate::vk::PFN_vkGetPhysicalDeviceImageFormatProperties2`]\n\n* []() VUID-vkCmdSubpassShadingHUAWEI-flags-02696  \n   Any [`crate::vk::Image`] created with a [`crate::vk::ImageCreateInfo::flags`]containing [`crate::vk::ImageCreateFlagBits::CORNER_SAMPLED_NV`] sampled as a\n  result of this command **must** only be sampled using a[`crate::vk::SamplerAddressMode`] of[`crate::vk::SamplerAddressMode::CLAMP_TO_EDGE`]\n\n* []() VUID-vkCmdSubpassShadingHUAWEI-None-02697  \n   For each set *n* that is statically used by the [`crate::vk::Pipeline`] bound\n  to the pipeline bind point used by this command, a descriptor set **must**have been bound to *n* at the same pipeline bind point, with a[`crate::vk::PipelineLayout`] that is compatible for set *n*, with the[`crate::vk::PipelineLayout`] used to create the current [`crate::vk::Pipeline`], as\n  described in [[descriptorsets-compatibility]](#descriptorsets-compatibility)\n\n* []() VUID-vkCmdSubpassShadingHUAWEI-None-02698  \n   For each push constant that is statically used by the [`crate::vk::Pipeline`]bound to the pipeline bind point used by this command, a push constant\n  value **must** have been set for the same pipeline bind point, with a[`crate::vk::PipelineLayout`] that is compatible for push constants, with the[`crate::vk::PipelineLayout`] used to create the current [`crate::vk::Pipeline`], as\n  described in [[descriptorsets-compatibility]](#descriptorsets-compatibility)\n\n* []() VUID-vkCmdSubpassShadingHUAWEI-None-02699  \n   Descriptors in each bound descriptor set, specified via[`crate::vk::PFN_vkCmdBindDescriptorSets`], **must** be valid if they are statically\n  used by the [`crate::vk::Pipeline`] bound to the pipeline bind point used by\n  this command\n\n* []() VUID-vkCmdSubpassShadingHUAWEI-None-02700  \n   A valid pipeline **must** be bound to the pipeline bind point used by this\n  command\n\n* []() VUID-vkCmdSubpassShadingHUAWEI-commandBuffer-02701  \n   If the [`crate::vk::Pipeline`] object bound to the pipeline bind point used by\n  this command requires any dynamic state, that state **must** have been set\n  or inherited (if the `[[VK_NV_inherited_viewport_scissor]](#VK_NV_inherited_viewport_scissor)` extension is\n  enabled) for [`Self::command_buffer`], and done so after any previously bound\n  pipeline with the corresponding state not specified as dynamic\n\n* []() VUID-vkCmdSubpassShadingHUAWEI-None-02859  \n   There **must** not have been any calls to dynamic state setting commands\n  for any state not specified as dynamic in the [`crate::vk::Pipeline`] object\n  bound to the pipeline bind point used by this command, since that\n  pipeline was bound\n\n* []() VUID-vkCmdSubpassShadingHUAWEI-None-02702  \n   If the [`crate::vk::Pipeline`] object bound to the pipeline bind point used by\n  this command accesses a [`crate::vk::Sampler`] object that uses unnormalized\n  coordinates, that sampler **must** not be used to sample from any[`crate::vk::Image`] with a [`crate::vk::ImageView`] of the type[`crate::vk::ImageViewType::_3D`], [`crate::vk::ImageViewType::CUBE`],[`crate::vk::ImageViewType::_1D_ARRAY`], [`crate::vk::ImageViewType::_2D_ARRAY`] or[`crate::vk::ImageViewType::CUBE_ARRAY`], in any shader stage\n\n* []() VUID-vkCmdSubpassShadingHUAWEI-None-02703  \n   If the [`crate::vk::Pipeline`] object bound to the pipeline bind point used by\n  this command accesses a [`crate::vk::Sampler`] object that uses unnormalized\n  coordinates, that sampler **must** not be used with any of the SPIR-V`OpImageSample*` or `OpImageSparseSample*` instructions with`ImplicitLod`, `Dref` or `Proj` in their name, in any shader\n  stage\n\n* []() VUID-vkCmdSubpassShadingHUAWEI-None-02704  \n   If the [`crate::vk::Pipeline`] object bound to the pipeline bind point used by\n  this command accesses a [`crate::vk::Sampler`] object that uses unnormalized\n  coordinates, that sampler **must** not be used with any of the SPIR-V`OpImageSample*` or `OpImageSparseSample*` instructions that includes a\n  LOD bias or any offset values, in any shader stage\n\n* []() VUID-vkCmdSubpassShadingHUAWEI-None-02705  \n   If the [robust buffer access](#features-robustBufferAccess) feature is\n  not enabled, and if the [`crate::vk::Pipeline`] object bound to the pipeline\n  bind point used by this command accesses a uniform buffer, it **must** not\n  access values outside of the range of the buffer as specified in the\n  descriptor set bound to the same pipeline bind point\n\n* []() VUID-vkCmdSubpassShadingHUAWEI-None-02706  \n   If the [robust buffer access](#features-robustBufferAccess) feature is\n  not enabled, and if the [`crate::vk::Pipeline`] object bound to the pipeline\n  bind point used by this command accesses a storage buffer, it **must** not\n  access values outside of the range of the buffer as specified in the\n  descriptor set bound to the same pipeline bind point\n\n* []() VUID-vkCmdSubpassShadingHUAWEI-commandBuffer-02707  \n   If [`Self::command_buffer`] is an unprotected command buffer, any resource\n  accessed by the [`crate::vk::Pipeline`] object bound to the pipeline bind point\n  used by this command **must** not be a protected resource\n\n* []() VUID-vkCmdSubpassShadingHUAWEI-None-04115  \n   If a [`crate::vk::ImageView`] is accessed using `OpImageWrite` as a result\n  of this command, then the `Type` of the `Texel` operand of that\n  instruction **must** have at least as many components as the image view’s\n  format.\n\n* []() VUID-vkCmdSubpassShadingHUAWEI-OpImageWrite-04469  \n   If a [`crate::vk::BufferView`] is accessed using `OpImageWrite` as a result\n  of this command, then the `Type` of the `Texel` operand of that\n  instruction **must** have at least as many components as the buffer view’s\n  format.\n\n* []() VUID-vkCmdSubpassShadingHUAWEI-SampledType-04470  \n   If a [`crate::vk::ImageView`] with a [`crate::vk::Format`] that has a 64-bit channel\n  width is accessed as a result of this command, the `SampledType` of\n  the `OpTypeImage` operand of that instruction **must** have a `Width`of 64.\n\n* []() VUID-vkCmdSubpassShadingHUAWEI-SampledType-04471  \n   If a [`crate::vk::ImageView`] with a [`crate::vk::Format`] that has a channel width\n  less than 64-bit is accessed as a result of this command, the`SampledType` of the `OpTypeImage` operand of that instruction**must** have a `Width` of 32.\n\n* []() VUID-vkCmdSubpassShadingHUAWEI-SampledType-04472  \n   If a [`crate::vk::BufferView`] with a [`crate::vk::Format`] that has a 64-bit channel\n  width is accessed as a result of this command, the `SampledType` of\n  the `OpTypeImage` operand of that instruction **must** have a `Width`of 64.\n\n* []() VUID-vkCmdSubpassShadingHUAWEI-SampledType-04473  \n   If a [`crate::vk::BufferView`] with a [`crate::vk::Format`] that has a channel width\n  less than 64-bit is accessed as a result of this command, the`SampledType` of the `OpTypeImage` operand of that instruction**must** have a `Width` of 32.\n\n* []() VUID-vkCmdSubpassShadingHUAWEI-sparseImageInt64Atomics-04474  \n   If the[`sparseImageInt64Atomics`](#features-sparseImageInt64Atomics)feature is not enabled, [`crate::vk::Image`] objects created with the[`crate::vk::ImageCreateFlagBits::SPARSE_RESIDENCY`] flag **must** not be accessed by\n  atomic instructions through an `OpTypeImage` with a `SampledType`with a `Width` of 64 by this command.\n\n* []() VUID-vkCmdSubpassShadingHUAWEI-sparseImageInt64Atomics-04475  \n   If the[`sparseImageInt64Atomics`](#features-sparseImageInt64Atomics)feature is not enabled, [`crate::vk::Buffer`] objects created with the[`crate::vk::BufferCreateFlagBits::SPARSE_RESIDENCY`] flag **must** not be accessed\n  by atomic instructions through an `OpTypeImage` with a`SampledType` with a `Width` of 64 by this command.\n\n* []() VUID-vkCmdSubpassShadingHUAWEI-None-04931  \n   This command must be called in a subpass with bind point\n  VK\\_PIPELINE\\_BIND\\_POINT\\_SUBPASS\\_SHADING\\_HUAWEI.\n  No draw commands can be called in the same subpass.\n  Only one vkCmdSubpassShadingHUAWEI command can be called in a subpass.\n\nValid Usage (Implicit)\n\n* []() VUID-vkCmdSubpassShadingHUAWEI-commandBuffer-parameter  \n  [`Self::command_buffer`] **must** be a valid [`crate::vk::CommandBuffer`] handle\n\n* []() VUID-vkCmdSubpassShadingHUAWEI-commandBuffer-recording  \n  [`Self::command_buffer`] **must** be in the [recording state](#commandbuffers-lifecycle)\n\n* []() VUID-vkCmdSubpassShadingHUAWEI-commandBuffer-cmdpool  \n   The [`crate::vk::CommandPool`] that [`Self::command_buffer`] was allocated from **must** support graphics operations\n\n* []() VUID-vkCmdSubpassShadingHUAWEI-renderpass  \n   This command **must** only be called inside of a render pass instance\n\nHost Synchronization\n\n* Host access to [`Self::command_buffer`] **must** be externally synchronized\n\n* Host access to the [`crate::vk::CommandPool`] that [`Self::command_buffer`] was allocated from **must** be externally synchronized\n\nCommand Properties\n\n|[Command Buffer Levels](#VkCommandBufferLevel)|[Render Pass Scope](#vkCmdBeginRenderPass)|[Supported Queue Types](#VkQueueFlagBits)|\n|----------------------------------------------|------------------------------------------|-----------------------------------------|\n|           Primary  <br/>Secondary            |                  Inside                  |                Graphics                 |\n[](#_see_also)See Also\n----------\n\n[`crate::vk::CommandBuffer`]\n"]
    #[doc(alias = "vkCmdSubpassShadingHUAWEI")]
    pub unsafe fn cmd_subpass_shading_huawei(&self, command_buffer: crate::vk1_0::CommandBuffer) -> () {
        let _function = self.cmd_subpass_shading_huawei.expect(crate::NOT_LOADED_MESSAGE);
        let _return = _function(command_buffer as _);
        ()
    }
}
